/**
 * Copyright (c) 2020 ~ 2021 KylinSec Co., Ltd.
 * kiran-control-panel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 *
 * Author:     liuxinhao <liuxinhao@kylinsec.com.cn>
 */

#ifndef AVATARITEMBUTTON_H
#define AVATARITEMBUTTON_H

#include <QAbstractButton>
#include <QObject>

class AvatarItemButton : public QAbstractButton
{
    Q_OBJECT

public:
    AvatarItemButton(QWidget *parent = nullptr);
    virtual ~AvatarItemButton();
    void setIcon(const QString &iconPath);
    QString iconPath();

protected:
    void setIcon(const QIcon &icon);
    virtual void paintEvent(QPaintEvent *event) override;
    virtual void resizeEvent(QResizeEvent *event) override;
    virtual void enterEvent(QEvent *event) override;
    virtual void leaveEvent(QEvent *event) override;
    virtual void mouseMoveEvent(QMouseEvent *event) override;
    virtual void mousePressEvent(QMouseEvent *e) override;

private:
    QRect m_realRect;
    double m_radius;
    bool m_mouseEnter;
    bool m_hover;
    QString m_iconPath;
};

#endif  // AVATARITEMBUTTON_H
